# Created by pyp2rpm-1.0.1
%global pypi_name py4j

Name:           python-py4j
Version:        0.10.9.7
Release:        %mkrel 7
Group:          Development/Python
Summary:        Enables Python programs to dynamically access arbitrary Java objects

License:        BSD
URL:            https://www.py4j.org/
Source0:        https://github.com/bartdag/%{pypi_name}/archive/%{version}/%{name}-%{version}.tar.gz
Patch0:         %{pypi_name}-add-hamcrest-in-classpath.patch
Patch1:         %{pypi_name}-Base64-java8.patch

BuildArch:      noarch

BuildRequires:  pyproject-rpm-macros
BuildRequires:  java-devel
BuildRequires:  ant-junit
BuildRequires:  maven-local
BuildRequires:  pkgconfig(python3)

# Fedora unbundles hamcrest from junit
BuildRequires:  hamcrest

%description
Py4J enables Python programs running in a Python interpreter to
dynamically access Java objects in a Java Virtual Machine. Methods are
called as if the Java objects resided in the Python interpreter and
Java collections can be accessed through standard Python collection
methods.

%package -n     python3-%{pypi_name}
Summary:        Enables Python programs to dynamically access arbitrary Java objects
Group:          Development/Python
Requires:       py4j-jar
%{?python_provide:%python_provide python3-%{pypi_name}}

%description -n python3-%{pypi_name}
Py4J enables Python programs running in a Python interpreter to
dynamically access Java objects in a Java Virtual Machine. Methods are
called as if the Java objects resided in the Python interpreter and
Java collections can be accessed through standard Python collection
methods.

%package -n   py4j-jar
Summary: JAR file for py4j-jar

%description -n py4j-jar
JAR file for py4j.


%prep
%setup -q -n %{pypi_name}-%{version}
%autopatch -p1

# remove unneeded stuff
rm -r setup.py
find . -name \*.jar -print -delete

# remove unnecessary dependency on parent POM
%pom_remove_parent %{pypi_name}-java/pom.xml

# build jar without version in name
sed -i -r "s|(version=).*|\1|" %{pypi_name}-java/ant.properties
sed -i "s|'.*'|''|" %{pypi_name}-python/src/%{pypi_name}/version.py

# set default java version to avoid some warnings
sed -i "s|1\.6|1.8|g" %{pypi_name}-java/build.xml

sed -i "s|junit-.*\.jar|$(build-classpath junit)|g" %{pypi_name}-java/ant.properties
sed -i -r "s|(<javadoc.*classpath=)\"\"|\1\"$(build-classpath junit)\"|" %{pypi_name}-java/build.xml

# install jar later with maven
sed -i "/data_files/d" %{pypi_name}-python/setup.py

# build separately for python3 in special subfolder
cp -a %{pypi_name}-python %{pypi_name}-python3
sed -i -r -e 's|(executable=")python|\1%{__python3}|g' \
 -e 's|(executable="nosetests)|\1-%{python3-version}|g' \
 -e 's|%{pypi_name}-python|%{pypi_name}-python3|g' \
 %{pypi_name}-java/build.xml
sed -i "s|'.*'|'%{version}'|" %{pypi_name}-python3/src/%{pypi_name}/version.py

%build
pushd %{pypi_name}-java
ant jar
popd

pushd %{pypi_name}-python3
%pyproject_wheel
popd


%install
# to be the default for now).
pushd %{pypi_name}-python3
%pyproject_install
%pyproject_save_files py4j
popd

%mvn_file : %{pypi_name}/%{pypi_name}

%mvn_artifact %{pypi_name}-java/pom.xml %{pypi_name}-java/%{pypi_name}.jar
%mvn_install -J %{pypi_name}-java/javadoc
mkdir -p %{buildroot}%{_datadir}/%{pypi_name}
ln -sf %{_javadir}/%{pypi_name}/%{pypi_name}.jar %{buildroot}%{_datadir}/%{pypi_name}

pushd %{buildroot}%{_javadir}
ln -s py4j/py4j.jar py4j%{version}.jar
ln -s py4j/py4j.jar py4j.jar
popd

%files -n python3-%{pypi_name} -f %{pyproject_files}
%doc README.rst AUTHORS.txt CONTRIBUTING.rst LICENSE.txt MANIFEST.in

%files -n py4j-jar -f .mfiles
%license %{pypi_name}-java/LICENSE.txt
%dir %{_datadir}/%{pypi_name}
%{_datadir}/py4j/py4j.jar
%{_javadir}/py4j%{version}.jar
%{_javadir}/py4j.jar


%changelog
* Wed Jul 02 2025 umeabot <umeabot> 0.10.9.7-7.mga10
+ Revision: 2238722
- Mageia 10 Mass Rebuild

* Sat Mar 01 2025 wally <wally> 0.10.9.7-6.mga10
+ Revision: 2155556
- rebuild for python3.13

* Mon May 27 2024 ns80 <ns80> 0.10.9.7-5.mga10
+ Revision: 2068226
- rebuild for java 21

* Sat Jan 27 2024 papoteur <papoteur> 0.10.9.7-4.mga10
+ Revision: 2035461
- rebuild for python 3.12

* Fri Jan 06 2023 wally <wally> 0.10.9.7-3.mga9
+ Revision: 1930591
- fix python3dist version info

* Thu Jan 05 2023 daviddavid <daviddavid> 0.10.9.7-2.mga9
+ Revision: 1930110
- Remove unnecessary dependency on parent POM

* Thu Jan 05 2023 papoteur <papoteur> 0.10.9.7-1.mga9
+ Revision: 1930023
- new 0.10.9.7
- port to pyproject

* Tue Aug 02 2022 tv <tv> 0.10.9.2-3.mga9
+ Revision: 1874351
- Fix filelist
+ umeabot <umeabot>
- Mageia 9 Mass Rebuild

* Sun Apr 04 2021 joequant <joequant> 0.10.9.2-1.mga9
+ Revision: 1713285
- update to 0.10.9.2 / python 3.9

* Sat Sep 05 2020 daviddavid <daviddavid> 0.10.9-2.mga8
+ Revision: 1622313
- remove unneeded BR gradle
- unbundle hamcrest
- install with xmvn
- Rebuilt for JDK-11

* Thu Aug 20 2020 joequant <joequant> 0.10.9-1.mga8
+ Revision: 1616849
- update to 0.10.9

* Sun Feb 16 2020 umeabot <umeabot> 0.10.8.1-5.mga8
+ Revision: 1535075
- Mageia 8 Mass Rebuild

* Thu Oct 10 2019 daviddavid <daviddavid> 0.10.8.1-4.mga8
+ Revision: 1451122
- rebuild for python3.8
- drop python2 support

* Thu Jan 10 2019 shlomif <shlomif> 0.10.8.1-3.mga8
+ Revision: 1354143
- Rebuild for python3 3.7

* Sat Nov 10 2018 joequant <joequant> 0.10.8.1-2.mga7
+ Revision: 1329341
- fix pip name
- fix spec file
- find spec
- upgrade to py4j
- upgrade
- upgrade to 0.10.8.1

* Thu Sep 20 2018 umeabot <umeabot> 0.8.1-9.mga7
+ Revision: 1289758
- Mageia 7 Mass Rebuild

* Sat Aug 05 2017 pterjan <pterjan> 0.8.1-8.mga7
+ Revision: 1135558
- Rebuild for python 3.6

* Fri Feb 19 2016 umeabot <umeabot> 0.8.1-7.mga6
+ Revision: 970942
- Mageia 6 Mass Rebuild

* Sat Oct 10 2015 tv <tv> 0.8.1-6.mga6
+ Revision: 888828
- rebuild for python 3.5

* Wed Oct 15 2014 umeabot <umeabot> 0.8.1-5.mga5
+ Revision: 746592
- Second Mageia 5 Mass Rebuild

* Sat Sep 27 2014 tv <tv> 0.8.1-4.mga5
+ Revision: 729358
- rebuild for missing pythoneggs deps

* Tue Sep 16 2014 umeabot <umeabot> 0.8.1-3.mga5
+ Revision: 688232
- Mageia 5 Mass Rebuild

* Sat Jun 28 2014 joequant <joequant> 0.8.1-2.mga5
+ Revision: 640555
- symlink java jars

* Fri Jun 27 2014 joequant <joequant> 0.8.1-1.mga5
+ Revision: 640415
- ant junit
- add junit
- imported package python-py4j

